package result;

sub new {
    my ($class, $MethName, $HasTransp) = @_;
    my $self = {
        MethName  => $MethName,
        HasTransp => $HasTransp,
        Values    => {}
    };

    bless ($self, $class);
    return $self;
};

sub AddValues {
    my @Input = @_;

    for (my $i = 1; $i <= $#Input; $i++) {
        if ($Input[$i] eq "" or $Input[$i] < 0) {
            $Input[$i] = undef
        }
    }
    my ($self, $N, $IndexSize, $TimeMem1, $TimeMem2, $TimeMem3, $TimeDisk1, $TimeDisk2, $TimeDisk3, $TimeFlash1, $TimeFlash2, $TimeFlash3, $NumComp1, $NumComp2, $NumComp3) = @Input;


    ($self->{Values})->{"dict_$N"} = [$IndexSize, $TimeMem1, $TimeMem2, $TimeMem3, $TimeDisk1, $TimeDisk2, $TimeDisk3, $TimeFlash1, $TimeFlash2, $TimeFlash3, $NumComp1, $NumComp2, $NumComp3];

};

sub GetValues {
    my ($self, $N) = @_;

    if (!$self) {return ();}
    
    my $val = $self->{Values}; 

    my $res = $val->{"dict_$N"};
    if (!$res) {
        print "Undefined values requested for $self->{MethName} (HasTransp = $self->{HasTransp}) N = $N\n";
        return ();
    }
    return @{$res};
}

1;
