#include "langcase.h"

const char *  RussianKoi8Upper = "";
const char *  RussianKoi8Lower = "ţ";
const char *  LatinLower = "abcdefghijklmnopqrstuvwxyz'";
const char *  LatinUpper =  "ABCDEFGHIJKLMNOPQRSTUVWXYZ'";

CAlphaProp alpha;

CAlphaProp::CAlphaProp() {
    for (unsigned int c = 0; c < 256; ++c) {
        const char * p = strchr(RussianKoi8Lower, c); 
        if (p) {
            toUpperArray[c] = RussianKoi8Upper[p - RussianKoi8Lower];
            toLowerArray[c] = c;
            isAlphaArray[c] = 1;
        } else if (isalpha(c)) {
            toUpperArray[c] = toupper(c);
            toLowerArray[c] = tolower(c);
            isAlphaArray[c] = 1;
        } else {
            p = strchr(RussianKoi8Upper, c);
            if (p) {
                toLowerArray[c] = RussianKoi8Lower[p - RussianKoi8Upper];
                toUpperArray[c] = c;
                isAlphaArray[c] = 1;
            } else {
                isAlphaArray[c] = 0;
                toUpperArray[c] = c;
                toLowerArray[c] = c;
            }
        }
    }
}
