#ifndef RUS_H
#define RUS_H

#include <string.h>
#include <cctype>

struct CAlphaProp {
    CAlphaProp();
private:
    unsigned char toUpperArray[256];
    unsigned char toLowerArray[256];
    unsigned char isAlphaArray[256];

    friend char toupper_eng_rus(char c);
    friend char tolower_eng_rus(char c);
    friend bool isalpha_eng_rus(char c);
}; 

extern CAlphaProp alpha;

inline char toupper_eng_rus(char c)
{
    return alpha.toUpperArray[c];
}

inline char tolower_eng_rus(char c)
{
    return alpha.toLowerArray[c];
}

inline bool isalpha_eng_rus(char c)
{
    return alpha.isAlphaArray[c];
}

#endif
