#include "gensupercond.h"
#include <iostream>
#include <string>

using namespace std;

unsigned GenCondNG(ENGType Type, const char* pABC, const string& s, unsigned kerr, bool bHasTransp, StringHashSet& dict)
{    
    StringList lst;

    FillExpansionList(s, bHasTransp, kerr, &lst, pABC, kerr, false, 0, false);
    // Secondly generate condensed

    dict.clear();

    for (int i = 0; i < lst.size(); ++i) {
        dict.insert(lst[i]);
    }

    size_t  FullNgSize = dict.size();

    if (Type == eFull) {
        return FullNgSize;
    }

    bool bSubstrCheck = Type == eSuperCondensed;

    bool       bCont = false;
    bool       bFirst = true;
    do {
    StringHashSet dict1;
    for (StringHashSet::iterator it = dict.begin(); it != dict.end(); ++it) {
    #if 0
            if (bFirst) {cout << "@" << *it << "@" << endl;}
    #endif
            bool   ok = true;
            string pref;
            int sz = it->size();
            if (!bSubstrCheck) {
                for (int i = sz - 1; i > 0 /*&& i >= len - kerr*/; --i) {
                    string s = it->substr(0, i);
                    if (dict.find(s) != dict.end()) {
                        ok = false;
                        pref = s;
                        break;
                    }
                }
            } else {
                for (int i = sz; i > 0 /*&& i >= len - kerr*/; --i) 
                for (int j = 0; j < i; ++j) {
                    if (!j && i == sz) continue;
                    string s = it->substr(j, i - j);
                    if (dict.find(s) != dict.end()) {
                    #if 0
                        cout << *it << "#" << s << "#" << endl;
                    #endif
                        ok = false;
                        pref = s;
                        i = -1; 
                        break;
                    }
                }
            }
            if (ok) dict1.insert(*it);
            //else cout << "Prefix: " << *it << " -> " << pref <<  "  orig str " << pStr <<  endl;
        }
        bCont = (dict1.size() != dict.size()); // iterate until no string is deleted
        dict = dict1;
        bFirst = false;
    } while (bCont);
    
    return FullNgSize;
}


