#ifndef SIGN_H
#define SIGN_H

#include <iostream>
#include <iomanip>

#include "search.h"
#include "calchash.h"
class Sign {
  protected:
    int32 val;
    int   MaxDigit;
    const HMap & hsign;
    int32 FromString (const char *str) const;
  public: 
    int32 abs (int32);
    int32 abs () {
        return abs (val);
    };
    Sign (const HMap & _hsign, int _MaxDigit, const char *str);
    Sign (const HMap & _hsign, int _MaxDigit, int32 v);
    operator  int32 ()const;
    int32 operator - (const Sign &);   // |A xor B|
    int32 Diff (const Sign &);  // |A \   B| 
    int32 getVal() const {return val;}
};

std::ostream & operator << (std::ostream & out, Sign & s);

#endif  /* */
