#ifndef _CALCHASH
#define _CALCHASH

#include <algorithm>
#include <vector>
#include <cstring>
#include <cctype>
#include <unistd.h>
#include "hmap.h"

struct freqpair {
    double freq;
    unsigned char c;
     freqpair (double _freq, unsigned char _c):c (_c), freq (_freq) {;
    };
}

;

typedef std::vector < freqpair > vecfreqs;

class freqcmp {
  public:
    bool operator () (const freqpair & f1, const freqpair & f2) {
        return f1.freq < f2.freq;
}};

extern freqcmp varfreqcmp;

bool CalcHMap (int m, const vecfreqs & fdata, HMap &, bool print = false);

#endif
