#include <iostream>
#include <string>

#include "afuzzy.h"

using namespace std;

int main(void) {
    string         s1; 
    string         s2;
    unsigned int   d; 
    unsigned int   kerr;
    cout << "Test WITHOUT transps, ctrl+D to skip, input 2 words and acceptable error number" << endl;
    while(cin >> s1 && cin >> s2 && cin >> kerr) {
        afuzzy a(0);
        a.init(s1.c_str(), kerr);
        cout << "Result1 : " << a.checkRTR(s2.c_str(), s2.size()) << endl;
        cout << "Result2 : " << a.checkRTR(s2.c_str(), &d);
        cout << " result2 dist: " << d << endl;
    }
    cout << "Test WITH transps, ctrl+D to skip, input 2 words and acceptable error number" << endl;
    cin.clear();
    while(cin >> s1 && cin >> s2 && cin >> kerr) {
        afuzzy a(1);
        a.init(s1.c_str(), kerr);
        cout << "Result1 : " << a.checkRTR(s2.c_str(), s2.size()) << endl;
        cout << "Result2 : " << a.checkRTR(s2.c_str(), &d);
        cout << " result2 dist: " << d << endl;
    }
    return 0;
};


