#!/usr/bin/perl -w
use strict;
my %h;
my $TotalQty = 0;
my $avg = 0;
while(<STDIN>) {
    chomp;
    my $l = length($_);
    if (!defined($h{$l})) {$h{$l}=1;} else {$h{$l}++;}
    $avg = ($avg * $TotalQty + $l) / ($TotalQty  + 1.0);
    ++$TotalQty;
}
my $cumul = 0;
my @keys = sort({$a <=> $b} keys(%h));
print "Average: ".sprintf("%.1f\n", $avg);
for my $l (@keys) {
    my $qty = $h{$l};
    my $p = 100 * $qty / $TotalQty;
    $cumul += $p;
    print "$l: ".sprintf("%.1f %.1f qty %d\n", $p, $cumul, $qty);
}
