  dir=$1

  if [ ! -d "$dir" ] ;then
    echo "'$dir' should be a directory that contains method-specific binaries!"
    exit
  fi

  pushd $dir

  if [ ! -f indx ] ; then
    echo "$dir is not compiled!"
    exit 1
  fi

  TranspList=$2
  # For this one, search with transposition is not supported.
  if [ "$dir" = "AlternGenSuperCond" ] ; then
    TranspList="0"
  fi

  echo "Transp list: $TranspList"
  for transp in $TranspList ; do 
    if [ $transp = "0" ] ; then
      echo "$dir - no transpostions"
    else
      echo "$dir - with transpostions"
    fi
    # Remove db
    ../clear_dir.sh $DISK_DIR
    ../clear_dir.sh $FLASH_DIR
 
    # Run tests
    echo "Purge file: $PURGE_CACHE"
    echo ./indx $transp $PURGE_CACHE "$TestFileFunc" $dictList
    ./indx $transp $PURGE_CACHE "$TestFileFunc" $dictList
    # Remove db again
    ../clear_dir.sh $DISK_DIR
    ../clear_dir.sh $FLASH_DIR
  done

  popd
