#ifndef MYEXCEPT_HPP

#include <stdexcept>
#include <sstream>
#include <iostream>

#define THROW_RUNTIME_ERROR(msg) { \
    std::stringstream __DontUseThisVarInTheCode__; \
    __DontUseThisVarInTheCode__ << "Exception in file " << __FILE__ << " line: " << __LINE__ << " Function: " << __PRETTY_FUNCTION__ << " message: " << msg; \
    throw std::runtime_error(__DontUseThisVarInTheCode__.str()); \
}

#define THROW_AND_PRINT_RUNTIME_ERROR(msg) { \
    std::stringstream __DontUseThisVarInTheCode__; \
    __DontUseThisVarInTheCode__ << "Exception in file " << __FILE__ << " line: " << __LINE__ << " Function: " << __PRETTY_FUNCTION__ << " message: " << msg; \
    std::cerr << __DontUseThisVarInTheCode__.str() << std::endl; \
    throw std::runtime_error(__DontUseThisVarInTheCode__.str()); \
}



#endif
