#ifndef _SEARCH
#define _SEARCH

//#include "config.h"

#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
//#ifdef linux
//#include <tiff.h>
//#endif
#include <sys/stat.h>
#include <sys/types.h>
#include <time.h>
#include <ctype.h>

extern int errno;

typedef unsigned char uchar;
typedef uchar *puchar;
typedef char *pchar;
const int ucnt = 256;
const int rcnt = 256;
//---------------------------------
#ifndef linux
typedef unsigned char uint8;
typedef unsigned int uint16;
typedef unsigned long int uint32;
typedef signed char int8;
typedef signed int int16;
typedef signed long int int32;
#endif
//---------------------------------
const int MaxLen = 64;         // maximum string length let it be 128 chars
const int MaxPossibleError = 3;

class String {
    uchar str[MaxLen + 1];
public:
    String () {
        str[0] = 0;
    } 
    String (const uchar * s) {
        strcpy ((char *) str, (char *) s);
    }
    const uchar *LPCSTR () {
        return str;
    }
};

struct PTR {
    off_t   pos;
    uint8   len;
    PTR (off_t _pos, uint8 _len):pos (_pos), len (_len) {; } 
    PTR ():pos (0), len (0) {; }
};

//typedef list<String>  StringList;

#define _DEBUG

#endif
