#ifndef CMN_UTIL_H
#define CMN_UTIL_H

#include <string.h>
#include <errno.h>

#include <string>

inline std::string SysError(int eno) {
#if 0
    char buf[512];

    strerror_r(eno, buf, sizeof buf);

    return buf;
#else
    return strerror(eno);
#endif
}

inline std::string SysError() {
    return SysError(errno);
}

#if defined(__GNUC__) && __GNUC__ < 3 
#define COMPARE(pos,cnt,str) compare(str,pos, cnt)
#else
#define COMPARE(pos,cnt,str) compare(pos,cnt, str) //standard compare
#endif

#endif
