#ifndef EXCEPT_H

#include <stdexcept>
#include <sstream>

#define THROW_RUNTIME_ERROR(msg) { \
    std::stringstream err; \
    err << "Exception in file " << __FILE__ << " line: " << __LINE__ << " message: " << msg; \
    throw std::runtime_error(err.str()); \
}



#endif
