#ifndef GRAMFLT_H
#define GRAMFLT_H

#include <iostream>
#include <iomanip>

#include "../SignHash/sign.h"



unsigned int GetMaxDigit();

struct CFullNgramInfo {
    unsigned int    mWordId;
    unsigned int    mPos;
    unsigned int    mWordLen;
    Sign            mSign;
    CFullNgramInfo(unsigned int wordId, unsigned int pos, unsigned int wordLen, const char * pStr, const HMap & hmap) 
      : mWordId(wordId), mPos(pos), mWordLen(wordLen), mSign(Sign(hmap, GetMaxDigit(), pStr))
    {
    }
};

const HMap & getStandHmap();
std::ostream & operator <<(std::ostream & out, CFullNgramInfo & gram);

#endif
