#include <stdio.h>
#include <errno.h>

int main(int argc, char *argv[])
{
    if (argc != 2) {
        fprintf(stderr, "Usage %s <file to clear cache of>\n", argv[0]);
        return 1;
    }
    FILE *f = fopen(DEV_CLDEV, "w"); 
    if (!f) {
        perror("Cannot open dev");
        return 1;
    }
    if (fprintf(f, "%s", argv[1]) <= 0) {
        perror("Cannot write to dev");
        return 1;
    }
    fclose(f);
    return 0;
}
