#!/bin/bash
if [ -z "$1" -o -z "$2" -o -z "$3" -o -z "$4" ] ; then
    echo "Usage: $0 <TestVocDir> <language> <methlist> <dictlist> <opt transp list> <opt res file> <opt config file>"
    exit 1
fi
export TestVocDir="$1"
export langlist="$2"
export methlist="$3"
export dictlist="$4"
TranspList="$5"
ResFileBase="$6"
ConfFile="$7"

echo "Language list: $langlist"
for lang in $langlist ; do 
    echo "$i $lang"
    ./testSPEED.sh "$TestVocDir" $lang 1000 "$methlist" "$dictlist" "$TranspList"  "$ResFileBase" "$ConfFile"
done

