#!/bin/bash
#N=100
N=1000
M=8
kerr=3
cd afuzzy
lang="eng"
RES_BASE="../seqresults"

# NL tests
./benchfuzzy -ns1 -ne$kerr ../TestVoc/test${N}_${M}_${kerr}_$lang ../TestVoc/dict${M}_$lang > ${RES_BASE}.${lang}

# DNA tests
# Only transposition unaware searching
lang="dna"
for len in 11 20 ; do
    ./benchfuzzy -ns1 -ne$kerr ../TestVocDNA/test${N}_${M}.${len}_${kerr}_$lang ../TestVocDNA/dict${M}.${len}_$lang 0 > ${RES_BASE}.${len}.$lang
done
