#!/bin/bash
Dir="TestVocCLUEWEB09"
Lang="engnum"
. ./mainlist.sh
Len="4"
TestFileSize=1000

RES_FILE_BASE="results"

ConfFile=config.clueweb09

M=2
while [ "$Len" != "16" ] ; do
    RES_FILE="results.${Lang}"

    rm -f $RES_FILE

    DictList="${M}.${Len}"
    DictSyn="$Dir/dict${M}.${Len}_${Lang}"
    rm -f $DictSyn
    # Create a temporary dictionary synonym
    ln -s "$PWD/$Dir/dict${M}_${Lang}" $DictSyn

    echo $DictList
    # Searching with transpositions here
    ./testSPEED.sh $Dir $Lang $TestFileSize "$methlist" "$DictList" "1" "$RES_FILE_BASE" "$ConfFile"
    ./testSPEED_LEN_MF.sh $Dir $Lang "$DictList" "1" "$RES_FILE_BASE" "$ConfFile" 

    cat $RES_FILE >> "${RES_FILE}.$Len"

    
    Len=$(($Len + 1))

    # This is a temporary link
    rm -f $DictSyn
done

exit 0
