#!/bin/bash
if [ -z $1 -o -z $2 ] ; then
    echo "Usage: $0 <TestVocDir> <language> <res file base> <conf file>"
    exit 1
fi
TestVocDir=$1
langlist=$2
ResFileBase=$3
ConfFile=$4
TranspList="0 1"

for i in 2 4 ; do
    ./testSEL.sh "$TestVocDir" "$langlist" AlternGenIndexExpansion2 $i "$TranspList" $ResFileBase $confFile
done
for i in 2 4 ; do
    ./testSEL.sh "$TestVocDir" "$langlist" AlternGenMorFrank $i  "$TranspList" $ResFileBase $confFile
done
for i in 2 4 8 16 ; do
    ./testSEL.sh "$TestVocDir" "$langlist" AlternGenIndexExpansion  $i  "$TranspList" $ResFileBase $confFile
done
for i in 2 4 8 ; do
    ./testSEL.sh "$TestVocDir" "$langlist" Cole_et_al  $i  "$TranspList" $ResFileBase $confFile
done
exit 0
